#import "ButtonFullScreen.h"

@implementation ButtonFullScreen
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// delete focus ring
//	[self setFocusRingType:NSFocusRingTypeNone];

	[self setTarget:self];
	[self setAction:NSSelectorFromString(@"changeFullScreen:")];

	[self setEnabled:NO];

	// set notification
	NSNotificationCenter *nc=[NSNotificationCenter defaultCenter];
	[nc addObserver:self selector:@selector(handleVideoObjectDidChanged:) name:VIDEO_NOTIF_OBJECT_DID_CHANGED object:nil];
	[nc addObserver:self selector:@selector(handleFullScreenDidChanged:) name:WINDOW_NOTIF_FULLSCREEN_DID_CHANGED object:nil];

}
//------------------------------------
// changeFullScreen
//------------------------------------
- (IBAction)changeFullScreen:(id)sender
{
	// post notification
	NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
	[nc postNotificationName:WINDOW_NOTIF_FULLSCREEN_DID_ENTERED object:nil];
}
//------------------------------------
// handleVideoObjectDidChanged
//------------------------------------
- (void)handleVideoObjectDidChanged:(NSNotification *)notification
{
	NSDictionary *params = [notification object];
	BOOL hasVideo = [[params valueForKey:@"hasVideo"] boolValue];
	[self setEnabled:hasVideo];
}
//------------------------------------
// handleFullScreenDidChanged
//------------------------------------
- (void)handleFullScreenDidChanged:(NSNotification *)notification
{
	BOOL isFullScreen = [[notification object] boolValue];
	int tag = [self tag];

	NSImage *image = nil;

	if(tag == 0){
		if(isFullScreen == NO){
			image = [NSImage imageNamed:@"btn_window_full_on"];
		}else{
			image = [NSImage imageNamed:@"btn_window_full_off"];
		}
	}
	else if(tag == 1){
		if(isFullScreen == NO){
			image = [NSImage imageNamed:@"hud_btn_full_on"];
		}else{
			image = [NSImage imageNamed:@"hud_btn_full_off"];
		}
	}

	[self setImage:image];
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];

	[super dealloc];
}

@end
