#import "ButtonPlayRepeat.h"
#import "UserDefaultsExtension.h"

static NSString *defaultKey = @"optPlayRepeat";

@implementation ButtonPlayRepeat
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	[self setTarget:self];
	[self setAction:NSSelectorFromString(@"changePlayRepeat:")];

	// delete focus ring
	[self setFocusRingType:NSFocusRingTypeNone];

	[self changeButtonImage];

	// add observer
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults addObserver:self forKeyPath:defaultKey options:0 context:nil];

}
//=======================================================================
// action
//=======================================================================
//------------------------------------
// changePlayRepeat
//------------------------------------
- (IBAction)changePlayRepeat:(id)sender
{
	int playRepeat = [self defaultPlayRepeat];

	playRepeat++;
	if(playRepeat > VIDEO_PLAY_REPEAT_ONE){
		playRepeat = VIDEO_PLAY_REPEAT_OFF;
	}

	[self setDefaultIntValue:playRepeat key:defaultKey];

//	[self changePlayRepeatButtonImage];

}
//----------------------------------------
// changeButtonImage
//----------------------------------------
- (void)changeButtonImage
{

	NSImage *image = [NSImage imageNamed:@"btn_repeat_off"];

	// playRepeat
	switch([self defaultPlayRepeat]){
		case VIDEO_PLAY_REPEAT_OFF:
			image = [NSImage imageNamed:@"btn_repeat_off"];
			break;
		case VIDEO_PLAY_REPEAT_ALL:
			image = [NSImage imageNamed:@"btn_repeat_all"];
			break;
		case VIDEO_PLAY_REPEAT_ONE:
			image = [NSImage imageNamed:@"btn_repeat_one"];
			break;
	}

	[self setImage:image];

}
//------------------------------------
// observeValueForKeyPath
//------------------------------------
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{

	if([keyPath isEqualToString:defaultKey]){
		[self changeButtonImage];
	}
	
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{	
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults removeObserver:self forKeyPath:defaultKey];

    [super dealloc];
}
@end
