#import "ButtonPlayVideo.h"

@implementation ButtonPlayVideo
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// delete focus ring
	[self setFocusRingType:NSFocusRingTypeNone];

	// set key equivalent
	[self setKeyEquivalent:@" "];

	[self setEnabled:NO];

	// set notification
	NSNotificationCenter *nc=[NSNotificationCenter defaultCenter];
	[nc addObserver:self selector:@selector(handleVideoObjectDidChanged:) name:VIDEO_NOTIF_OBJECT_DID_CHANGED object:nil];
	[nc addObserver:self selector:@selector(handleVideoPlayDidChanged:) name:VIDEO_NOTIF_PLAY_DID_CHANGED object:nil];

}
//------------------------------------
// handleVideoObjectDidChanged
//------------------------------------
- (void)handleVideoObjectDidChanged:(NSNotification *)notification
{
	NSDictionary *params = [notification object];
	BOOL hasVideo = [[params valueForKey:@"hasVideo"] boolValue];
	[self setEnabled:hasVideo];
}
//------------------------------------
// handleVideoPlayDidChanged
//------------------------------------
- (void)handleVideoPlayDidChanged:(NSNotification *)notification
{
	BOOL isPlaying = [[notification object] boolValue];
	int tag = [self tag];

	NSImage *image = nil;

	if(tag == 0){
		if(isPlaying == YES){
			image = [NSImage imageNamed:@"btn_ctrl_stop"];
		}else{
			image = [NSImage imageNamed:@"btn_ctrl_play"];
		}
	}
	else if(tag == 1){
		if(isPlaying == YES){
			image = [NSImage imageNamed:@"hud_btn_stop"];
		}else{
			image = [NSImage imageNamed:@"hud_btn_play"];
		}
	}

	[super setImage:image];
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];

	[super dealloc];
}

@end
