#import "ButtonThumbsFrameSec.h"
#import "UserDefaultsExtension.h"

static NSString *defaultKey = @"optThumbsFrameType";

@implementation ButtonThumbsFrameSec
//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	[self changeButtonEnabled];

	// add observer
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults addObserver:self forKeyPath:defaultKey options:0 context:nil];

}
//=======================================================================
// action
//=======================================================================
//----------------------------------------
// changeButtonEnabled
//----------------------------------------
- (void)changeButtonEnabled
{

	BOOL enable = NO;

	if([self defaultIntValue:defaultKey] == 1){
		enable = YES;
	}else{
		enable = NO;
	}
	[self setEnabled:enable];

}
//------------------------------------
// observeValueForKeyPath
//------------------------------------
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{

	if([keyPath isEqualToString:defaultKey]){
		[self changeButtonEnabled];
	}
	
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{	
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults removeObserver:self forKeyPath:defaultKey];

    [super dealloc];
}
@end
