#import "CMFilelistHeader.h"
#import "FilelistTableView.h"

@implementation CMFilelistHeader

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	//set delegate parent menu
	[super setDelegate:self];

}
//------------------------------------
// set Menu Item
//------------------------------------
-(void)setMenuItem
{

	NSArray *myColmun;
	NSString *title;
	NSString *identifier;
	NSString *senderString;
	int state;
	id record;

	// remove all items
    NSEnumerator *enumItemArray = [[self itemArray] objectEnumerator];
    while (record = [enumItemArray nextObject]) {
		[self removeItem:record];
	}

	// add item 
	NSArray *menuItems = [self menuItems];
	NSMenuItem *menuItem;

    NSEnumerator *enumColArray = [menuItems objectEnumerator];
    while (record = [enumColArray nextObject]) {

		myColmun = [record componentsSeparatedByString:@","];
		title = [myColmun objectAtIndex:0];
		identifier = [myColmun objectAtIndex:1];

		if([filelistTableView isShowColumn:identifier] == YES){
			state = 1;
		}else{
			state = 0;
		}

		senderString = [NSString stringWithFormat: @"%@,%d",identifier,state];

		menuItem = [[[NSMenuItem alloc] initWithTitle:title action:@selector(changeColumnState:) keyEquivalent:@""] autorelease];
		[menuItem setTarget:filelistTableView];
		[menuItem setRepresentedObject:senderString];
		[menuItem setState:state];
         
        [self addItem:menuItem];
    }
	[menuItems release];

}
//------------------------------------
// menuItems
//------------------------------------
-(NSArray*)menuItems
{
	return 	[[NSArray alloc] initWithObjects: 
				@"Icon,fileIcon",
				@"Image,image",
//				@"Description,description",
				@"Path,filePath",
				@"Time,playTime",
				@"Size,fileSize",
				@"FileDate,fileDate",
				@"FileType,fileTypeName",
				@"ID,uniqueId",
				@"AddDate,addDate",
				nil
			];
}
//------------------------------------
// menuNeedsUpdate
//------------------------------------
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self setMenuItem];
}

@end
