#import <Cocoa/Cocoa.h>
#import "ItemInfoStatus.h"
#import "KeyInfoStatus.h"

@interface ChapterMatrix : NSMatrix
{

	IBOutlet id viewChapter;

	IBOutlet NSButton *btnPlay;
	IBOutlet NSButton *btnAdd;
	IBOutlet NSButton *btnRemove;
	IBOutlet NSButton *btnGear;

	id selectedObject_;
	int selectedIndex_;
	int startIndex_;
	int endIndex_;

}
- (IBAction)changeMatrix:(id)sender;

- (void)changePlayButtonEnable;
- (void)changeAddButtonEnable;
- (void)changeRemoveButtonEnable;
- (void)changeGearButtonEnable;

- (void)createMatrix:(int)startIndex endIndex:(int)endIndex;
- (void)clearMatrix;
- (void)updateSelectedCell;
- (BOOL)selectMovedCell:(int)arrow isShift:(BOOL)isShift isCmd:(BOOL)isCmd;
- (BOOL)selectIndexCell:(int)index isShift:(BOOL)isShift isCmd:(BOOL)isCmd;
- (void)changeSelectionIndexes:(int)index
						isShift:(BOOL)isShift
						isCmd:(BOOL)isCmd;
- (void)adjustScrollPosition:(NSPoint)cellPosition;
- (NSSize)calcCellSize:(NSSize)frameSize cols:(int)cols;

- (int)maxCols;

- (void)setStartIndex:(int)index;
- (int)startIndex;
- (void)setEndIndex:(int)index;
- (int)endIndex;

- (void)setSelectedObject:(id)selectedObject;
- (id)selectedObject;
- (void)setSelectedIndex:(int)index;
- (int)selectedIndex;

- (int)lastIndex;
- (int)totalResults;

@end
