#import "ConvertExtension.h"
#import "UserDefaultsExtension.h"

@implementation NSObject(convertExtension_)

//------------------------------------
// convert file size string
//------------------------------------
- (NSString*)convertFileSizeToString:(double)fileSize
{
	NSString *fileSizeName = @"";

	// fileSize < 1MB
/*
	if(fileSize < 1024){
		fileSize = fileSize / 1024;
		fileSizeName = @"KB";
	}
*/
	if(fileSize < (1024 * 1024)){
		fileSize = fileSize / 1024;
		fileSizeName = @"KB";
	}
	// fileSize < 1GB
	else if(fileSize < (1024 * 1024 * 1024)){
		fileSize = fileSize / (1024 * 1024);
		fileSizeName = @"MB";
	}
	else{
		fileSize = fileSize / (1024 * 1024 * 1024);
		fileSizeName = @"GB";
	}

	return [NSString stringWithFormat: @"%.1f %@",fileSize,fileSizeName];

}
//------------------------------------
// convertTimeToString
//------------------------------------
- (NSString*)convertTimeToString:(int)timeSec
{

/*
	output format
	 1:11:11
	   11:11
	    1:11
	    0:11
	    0:01
*/

	NSString *timeStr;
	NSString *hourStr;
	NSString *minStr;
	NSString *secStr;

	int hour = 0;
	int min = 0;
	int sec = 0;

	if(timeSec >= 3600){
		hour = timeSec / 3600;
		timeSec = timeSec % 3600;
	}

	if(timeSec >= 60){
		min = timeSec / 60;
		timeSec = timeSec % 60;
	}

	sec = timeSec;

	// hour format
	hourStr = [NSString stringWithFormat:@"%d",hour];

	// min format
	if(hour > 0){
		if(min < 10){
			minStr = [NSString stringWithFormat:@"0%d",min];
		}else{
			minStr = [NSString stringWithFormat:@"%d",min];
		}
	}else{
		minStr = [NSString stringWithFormat:@"%d",min];
	}

	// sec format
	if(sec < 10){
		secStr = [NSString stringWithFormat:@"0%d",sec];
	}else{
		secStr = [NSString stringWithFormat:@"%d",sec];
	}

	// time format
	if(hour > 0){
		timeStr = [NSString stringWithFormat:@"%@:%@:%@",hourStr, minStr, secStr];
	}else{
		timeStr = [NSString stringWithFormat:@"%@:%@", minStr, secStr];
	}

	return timeStr;

}
//------------------------------------
// convertDateToString
//------------------------------------
- (NSString*)convertDateToString:(NSDate*)date formatString:(NSString*)formatString
{
	NSDateFormatter *formatter = [
					[[NSDateFormatter alloc] 
						initWithDateFormat:formatString
						allowNaturalLanguage:FALSE
					]
	autorelease];

	return [formatter stringFromDate:date];
}
//------------------------------------
// convertToComma
//------------------------------------
- (NSString*)convertToComma:(int)value
{
	NSNumber *number=[NSNumber numberWithInt:value];
	NSNumberFormatter *formatter=[[[NSNumberFormatter alloc] init] autorelease];

//	[formatter setThousandSeparator:@","];
//	[formatter setHasThousandSeparators:YES];
	[formatter setFormat:@"#,##0;0;-#,##0"];

	return [formatter stringForObjectValue:number];
}
//------------------------------------
// convertToZeroFormat
//------------------------------------
- (NSString*)convertToZeroFormat:(int)value
{
	NSNumber *number=[NSNumber numberWithInt:value];
	NSNumberFormatter *formatter=[[[NSNumberFormatter alloc] init] autorelease];

	[formatter setFormat:@"00000000;00000000;-00000000"];

	return [formatter stringForObjectValue:number];
}
//------------------------------------
// convertToResultString
//------------------------------------
- (NSString*)convertToResultString:(int)startIndex endIndex:(int)endIndex totalResults:(int)totalResults
{
	
	return [NSString stringWithFormat:@"%@ - %@ of %@",
								[self convertToComma:startIndex],
								[self convertToComma:endIndex],
								[self convertToComma:totalResults]
			];
}

//------------------------------------
// getLastSeparatedString
//------------------------------------
- (NSString*)getLastSeparatedString:(NSString*)str sep:(NSString*)sep
{
	NSString *retStr = str;

	NSArray *cols = [str componentsSeparatedByString:sep];
	if([cols count] > 0){
		retStr = [cols objectAtIndex:[cols count] - 1];
	}

	return retStr;
}

@end