/* FileItemManager */

#import <Cocoa/Cocoa.h>
#import <QTKit/QTKit.h>
#import "ImportTypes.h"
#import "ItemInfoStatus.h"

@interface FileItemManager : NSObject
{
	
	IBOutlet id viewLog;
	IBOutlet id viewProcStatus;
	IBOutlet id tbArrayController;
	IBOutlet id MacVideoTunes_AppDelegate;

	NSString *logString_;
	int targetCount_;
	int invalidCount_;
	int checkedCount_;

}

- (BOOL)importItemWithFilePaths:(NSArray*)filePaths
					targetItem:(id)targetItem
					targetType:(int)targetType;
- (NSMutableArray*)getImportFilePaths:(NSArray*)filePaths isErr:(BOOL*)isErr;
- (NSMutableArray*)getTargetFilePaths:(NSString*)filePath checkedPaths:(NSMutableArray*)checkedPaths isErr:(BOOL*)isErr;
- (BOOL)checkAcceptFilePath:(NSString*)filePath isDir:(BOOL)isDir;

- (NSArray*)insertFilelistWithFilePaths:(NSArray*)filePaths;
- (void)createItemThumbsImageWithItems:(NSArray*)items;
- (void)removeFilelistWithItems:(NSArray*)items;

- (void)addItemsToPlaylist:(NSManagedObject*)targetItem items:(NSArray*)items;
- (void)removeItemsFromPlaylist:(NSManagedObject*)targetItem items:(NSArray*)items;

- (void)setLogString:(NSString *)logString;
- (NSString *)logString;
- (void)appendLogString:(NSString *)logString;

@end
