/* FullScreenWindow */

#import <Cocoa/Cocoa.h>
#import "WindowInfoStatus.h"

@interface FullScreenWindow: NSWindow

{
	BOOL isFullScreen_;
	NSRect oldRect_;
	float titleBarHeight_;
	BOOL showController_;
	BOOL isTopScreen_;

}
- (void)changeFullScreen;
- (void)changeFullScreenWithHideController;
- (void)changeFullScreenWithHideControllerWithTimer;

- (void)changeTopScreen;

- (void)setFullScreen:(BOOL)isFullScreen animate:(BOOL)animate;
- (void)postWindowFullScreenDidChangedNotification:(BOOL)isFullScreen;
- (void)postWindowFullScreenDidClosedNotification;
- (void)postWindowTopScreenDidChangedNotification:(BOOL)isTopScreen;

- (void)changeWindowLevel;
- (void)restoreWindowLevel;

- (void)setIsFullScreen:(BOOL)isFullScreen;
- (BOOL)isFullScreen;

- (void)setIsTopScreen:(BOOL)isTopScreen;
- (BOOL)isTopScreen;

- (void)setShowController:(BOOL)showController;
- (BOOL)showController;


@end


