#import <Cocoa/Cocoa.h>
#import "KeyInfoStatus.h"

@interface GalleryMatrix : NSMatrix
{

	IBOutlet id viewGallery;
	IBOutlet NSArrayController *filelistArrayController;

	IBOutlet NSTextField *txtPageResult;

	IBOutlet NSButton *btnPlay;
	IBOutlet NSButton *btnPagePrev;
	IBOutlet NSButton *btnPageNext;

	id selectedObject_;
	int selectedIndex_;
	int startIndex_;
	int endIndex_;

}
- (IBAction)initMatrix:(id)sender;
- (IBAction)changeMatrix:(id)sender;
- (IBAction)changeMatrixPage:(id)sender;
- (IBAction)moveMatrixPage:(id)sender;

- (void)changePlayButtonEnable;
- (void)changePageButtonEnable;
- (NSDictionary*)checkIsChangedPage;
- (void)setPageResultStatus;

- (void)createMatrix:(int)startIndex endIndex:(int)endIndex;
- (void)clearMatrix;
- (void)updateSelectedCell;
- (BOOL)selectMovedCell:(int)arrow isShift:(BOOL)isShift isCmd:(BOOL)isCmd;
- (BOOL)selectIndexCell:(int)index isShift:(BOOL)isShift isCmd:(BOOL)isCmd;
- (void)changeSelectionIndexes:(int)index
						isShift:(BOOL)isShift
						isCmd:(BOOL)isCmd;
//- (void)adjustScrollPosition:(NSPoint)cellPosition;
- (NSSize)calcCellSize:(NSSize)frameSize cols:(int)cols rows:(int)rows;

- (int)maxCols;
- (int)maxRows;


- (void)setStartIndex:(int)index;
- (int)startIndex;
- (void)setEndIndex:(int)index;
- (int)endIndex;

- (void)setSelectedObject:(id)selectedObject;
- (id)selectedObject;
- (void)setSelectedIndex:(int)index;
- (int)selectedIndex;

- (int)lastIndex;
- (int)totalResults;
- (int)maxResults;

@end
