#import "HelperExtension.h"
#import "FileAttributeExtension.h"
#import "DialogExtension.h"

@implementation NSObject(helperExtension_)

//------------------------------------
// showFileInFinder
//------------------------------------
- (void)showFileInFinder:(NSString*)filePath
{
	// file is not found
	if([self checkFileExist:filePath] == FILE_EXIST_NOT_FOUND){
		[self displayMessageAlertFileIsNotFound:filePath];
		return;
	}

	[[NSWorkspace sharedWorkspace] selectFile:filePath inFileViewerRootedAtPath:nil];

}
//------------------------------------
// openFileWithApp
//------------------------------------
- (void)openFileWithApp:(NSString*)appPath filePaths:(NSArray*)filePaths
{

	// app is not found
	if(![appPath isEqualToString:@""]){
		if([self checkFileExist:appPath] == FILE_EXIST_NOT_FOUND){
			[self displayMessageAlertAppIsNotFound:appPath];
			return;
		}
	}

	int count = [filePaths count];

	// alert
	if(count > 10){
		int result = [self displayMessage:@"alert"
								messageText:[NSString stringWithFormat:@"Open over 10 (%d) files.", count]
								infoText:@"Continue open?"
								btnList:@"Open,Cancel"
				];
		if(result != NSAlertFirstButtonReturn){
			return;
		}
	}

	int i;
	NSString *filePath;

	// open files
	for(i = 0; i < count; i++){

		filePath = [filePaths objectAtIndex:i];

		// file is not found
		if([self checkFileExist:filePath] == FILE_EXIST_NOT_FOUND){
			continue;
		}

		// default
		if([appPath isEqualToString:@""]){
			[[NSWorkspace sharedWorkspace] openFile:filePath];
		}
		// app
		else{
			[[NSWorkspace sharedWorkspace] openFile:filePath withApplication:appPath];
		}
	}
}
@end