#import "MenuItemApplist.h"
#import "ViewMain.h"
#import "ViewPrefs.h"

@implementation MenuItemApplist

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	// createSubMenu
	menuApplist_ = [[[NSMenu alloc] initWithTitle:@"ApplistMenu"] autorelease];
	[self setSubMenuApplist:menuApplist_];

	//set delegate menu
	[menuApplist_ setDelegate: self ];
}

//------------------------------------
// set Sub Menu Applist
//------------------------------------
-(void)setSubMenuApplist:(NSMenu*)aMenu
{
	id record;
	NSString *itemName;
	NSString *filePath;

	// remove menuItem
    NSEnumerator *enumArray = [[aMenu itemArray] objectEnumerator];
    while (record = [enumArray nextObject]) {
		[aMenu removeItem:record];
	}

	NSArray *fetchArray = [applistArrayController arrangedObjects];

	// add item for finder
	NSMenuItem *menuItemDefault = [[[NSMenuItem alloc] initWithTitle:@"Finder" action:@selector(openItemWithApp:) keyEquivalent:@""] autorelease];
 	[menuItemDefault setTarget:viewMain];
	[menuItemDefault setRepresentedObject:nil];
	[menuItemDefault setImage:[NSImage imageNamed:@"icon_finder"]];
 	[aMenu addItem:menuItemDefault];

	// add item separator
	if([fetchArray count] > 0){
		[aMenu addItem:[NSMenuItem separatorItem]];
	}

	// add item from applist
    NSEnumerator *enumFetchArray = [fetchArray objectEnumerator];
	NSMenuItem *menuItem;
    while (record = [enumFetchArray nextObject]) {

		itemName = @"";
		filePath = @"";
		if([record valueForKey: @"appName" ]){
			itemName = [record valueForKey: @"appName" ];
		}
		if([record valueForKey: @"filePath" ]){
			filePath = [record valueForKey: @"filePath" ];
		}

		menuItem = [[[NSMenuItem alloc] initWithTitle:itemName action:@selector(openItemWithApp:) keyEquivalent:@""] autorelease];
		[menuItem setTarget:viewMain];
		[menuItem setRepresentedObject:record];

		NSImage *iconImage = [[NSWorkspace sharedWorkspace] iconForFile:filePath];
		[iconImage setSize:NSMakeSize(16,16)];
		[iconImage setScalesWhenResized:YES];
		[menuItem setImage:iconImage];
        [aMenu addItem:menuItem];
    }

	// add item separator
 	[aMenu addItem:[NSMenuItem separatorItem]];

	// add item for pereference
	NSMenuItem *menuItemSetting = [[[NSMenuItem alloc] initWithTitle:@"Settings.." action:@selector(openPrefsWindowWithTabIdentifier:) keyEquivalent:@""] autorelease];
 	[menuItemSetting setTarget:viewPrefs];
//	[menuItemSetting setRepresentedObject:[NSNumber numberWithInt:1]];
	[menuItemSetting setRepresentedObject:@"helper"];
	[menuItemSetting setImage:[NSImage imageNamed:@"icon_gear"]];

 	[aMenu addItem:menuItemSetting];
	[self setSubmenu:aMenu];
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[menuApplist_ release];	
    [super dealloc];
}

//=======================================================================
#pragma mark - Delegate -
//=======================================================================
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self setSubMenuApplist:menu];
}

@end
