#import "MenuItemChaperInterval.h"
#import "ViewChapter.h"
#import "UserDefaultsExtension.h"

@implementation MenuItemChaperInterval

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	// set action
	[self setTarget:self];
	[self setAction:NSSelectorFromString(@"nullAction:")];

	// createSubMenu
	subMenu_ = [[[NSMenu alloc] initWithTitle:@"chapterIntervalMenu"] autorelease];
	[self createSubMenu:subMenu_];

	//set delegate menu
	[subMenu_ setDelegate:self];

}

//------------------------------------
// changeChapterInterval
//------------------------------------
- (IBAction)changeChapterInterval:(id)sender
{
	int interval = [[sender representedObject] intValue];

	// set default
	[self setDefaultIntValue:interval key:@"optChapterAutoIntervalSec"];

	// 
	[viewChapter createItemChapter:sender];

}
//------------------------------------
// nullAction
//------------------------------------
- (IBAction)nullAction:(id)sender
{
	// null
}
//------------------------------------
// createSubMenu
//------------------------------------
- (void)createSubMenu:(NSMenu*)aMenu
{

	NSArray *cols;
	NSString *itemName;
	NSString *title;
	int interval;
	int i;
	id record;
	int chapterInterval = [self defaultIntValue:@"optChapterAutoIntervalSec"];
	int durationSec = [viewChapter movieDurationSec];
	int totalCount = 0;

	// remove menuItem
	while (record = [[[aMenu itemArray] objectEnumerator] nextObject]) {
		[aMenu removeItem:record];
	}

	NSArray *menuItems = [self menuItems];
	NSMenuItem *menuItem;

	for(i = 0; i < [menuItems count]; i++){

		cols = [[menuItems objectAtIndex:i] componentsSeparatedByString:@","];

		// add item separator
        if([[cols objectAtIndex:0] isEqualToString:@"-"]){
			[aMenu addItem:[NSMenuItem separatorItem]];
			continue;
		}

		itemName = [cols objectAtIndex:0];
		interval = [[cols objectAtIndex:1] intValue];
		totalCount = durationSec / interval + 1;

		title = [NSString stringWithFormat:@"%@ / %d", itemName, totalCount];

		// set action
 		SEL sel = NSSelectorFromString(@"changeChapterInterval:");

		menuItem = [[[NSMenuItem alloc] initWithTitle:title action:sel keyEquivalent:@""] autorelease];
		[menuItem setTarget:self];
		[menuItem setRepresentedObject:[NSNumber numberWithInt:interval]];
		[menuItem setTag:1];

		// set state
		if(interval == chapterInterval){
			[menuItem setState:1];
		}else{
			[menuItem setState:0];
		}

		[aMenu addItem:menuItem];
	}

	[self setSubmenu:aMenu];

	[menuItems release];

}
//------------------------------------
// updateSubMenu
//------------------------------------
- (void)updateSubMenu:(NSMenu*)aMenu
{

	int interval;
	id menuItem;
	int chapterInterval = [self defaultIntValue:@"optChapterAutoIntervalSec"];

	NSEnumerator *enumArray = [[aMenu itemArray] objectEnumerator];
	while (menuItem = [enumArray nextObject]) {
		interval = [[menuItem representedObject] intValue];
		// set state
		if(interval == chapterInterval){
			[menuItem setState:1];
		}else{
			[menuItem setState:0];
		}
	}

}

//------------------------------------
// menuItems
//------------------------------------
- (NSArray*)menuItems
{
	return [[NSArray alloc] initWithObjects: 
//				@" 5 sec,5",
//				@"10 sec,10",
				@"15 sec,15",
				@"30 sec,30",
				@"60 sec,60",
				@"-,0",
				@"5 min,300",
				@"10 min,600",
//				@"15 min,900",
				@"30 min,1800",
				nil
			];
}

//------------------------------------
// menuNeedsUpdate
//------------------------------------
-( void )menuNeedsUpdate:(NSMenu *)menu
{
//	[self updateSubMenu:menu];
	[self createSubMenu:menu];
	
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[subMenu_ release];	
    [super dealloc];
}
@end
