#import "MenuItemPlayRate.h"

@implementation MenuItemPlayRate

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	// set action
	[self setTarget:self];
	[self setAction:NSSelectorFromString(@"nullAction:")];

	// createSubMenu
	subMenu_ = [[[NSMenu alloc] initWithTitle:@"playRateMenu"] autorelease];
	[self createSubMenu:subMenu_];

	//set delegate menu
	[subMenu_ setDelegate:self];

	[self setMenuState:1.0];

	// set notification
	NSNotificationCenter *nc=[NSNotificationCenter defaultCenter];
	[nc addObserver:self selector:@selector(handleVideoRateDidChanged:) name:VIDEO_NOTIF_RATE_DID_CHANGED object:nil];

}

//------------------------------------
// changePlayRate
//------------------------------------
- (IBAction)changePlayRate:(id)sender
{

	float rate = [[sender representedObject] floatValue];

	// post notification
	NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
	[nc postNotificationName:VIDEO_NOTIF_RATE_DID_ENTERED object:[NSNumber numberWithFloat:rate]];

}
//------------------------------------
// nullAction
//------------------------------------
- (IBAction)nullAction:(id)sender
{
	// null
}
//------------------------------------
// createSubMenu
//------------------------------------
- (void)createSubMenu:(NSMenu*)aMenu
{

	NSArray *cols;
	NSString *itemName;
	float rate;
	int i;
	id record;

	// remove menuItem
	while (record = [[[aMenu itemArray] objectEnumerator] nextObject]) {
		[aMenu removeItem:record];
	}

	NSArray *menuItems = [self menuItems];
	NSMenuItem *menuItem;

	for(i = 0; i < [menuItems count]; i++){

		cols = [[menuItems objectAtIndex:i] componentsSeparatedByString:@","];

		// add item separator
        if([[cols objectAtIndex:0] isEqualToString:@"-"]){
			[aMenu addItem:[NSMenuItem separatorItem]];
			continue;
		}

		itemName = [cols objectAtIndex:0];
		rate = [[cols objectAtIndex:1] floatValue];

		// set action
 		SEL sel = NSSelectorFromString(@"changePlayRate:");

		menuItem = [[[NSMenuItem alloc] initWithTitle:itemName action:sel keyEquivalent:@""] autorelease];
		[menuItem setTarget:self];
		[menuItem setRepresentedObject:[NSNumber numberWithFloat:rate]];

		[aMenu addItem:menuItem];
	}

	[self setSubmenu:aMenu];

	[menuItems release];

}
//------------------------------------
// setMenuState
//------------------------------------
- (void)setMenuState:(float)playRate
{

	float rate;
	id menuItem;

	NSEnumerator *enumArray = [[[self submenu] itemArray] objectEnumerator];
	while (menuItem = [enumArray nextObject]) {
		rate = [[menuItem representedObject] floatValue];
		// set state
		if(rate == playRate){
			[menuItem setState:1];
		}else{
			[menuItem setState:0];
		}
	}

}
//------------------------------------
// handleFullScreenDidChanged
//------------------------------------
- (void)handleVideoRateDidChanged:(NSNotification *)notification
{
	[self setMenuState:[[notification object] floatValue]];
}

//------------------------------------
// menuItems
//------------------------------------
- (NSArray*)menuItems
{
	return [[NSArray alloc] initWithObjects: 
				@"x 0.5,0.5,",
				@"x 1.0,1.0,",
				@"x 1.5,1.5,",
				@"x 2.0,2.0,",
				@"x 3.0,3.0,",
//				@"x 4.0,4.0,",
				nil
			];
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];

	[subMenu_ release];	
    [super dealloc];
}
@end
