#import "MenuItemPlayRepeat.h"
#import "ViewPlayer.h"
#import "UserDefaultsExtension.h"

@implementation MenuItemPlayRepeat

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	//set delegate menu
	NSMenu *playRepeatMenu = [self submenu];
	[playRepeatMenu setDelegate:self];

	// set menu action
	[self setMenuAction:playRepeatMenu];

	// set action
	[self setTarget:self];
	[self setAction:NSSelectorFromString(@"nullAction:")];

}
//------------------------------------
// changePlayRepeat
//------------------------------------
- (IBAction)changePlayRepeat:(id)sender
{
	int playRepeat = [sender tag];
	[self setDefaultIntValue:playRepeat key:@"optPlayRepeat"];
}
//------------------------------------
// nullAction
//------------------------------------
- (IBAction)nullAction:(id)sender
{
	// null action
}
//------------------------------------
// setMenuAction
//------------------------------------
- (void)setMenuAction:(NSMenu*)aMenu
{

	id record;
	int i;

	SEL sel = NSSelectorFromString(@"changePlayRepeat:");

	NSArray *menuArray = [[aMenu itemArray] retain];

	for(i = 0; i < [menuArray count]; i++){

		record = [menuArray objectAtIndex:i];
		[record setTarget:self];
		[record setAction:sel];

	}

	[menuArray release];

}
//------------------------------------
// updateMenuItem
//------------------------------------
- (void)updateMenuItem:(NSMenu*)aMenu
{

	id record;
	int tag;
	int i;

	int playRepeat = [self defaultIntValue:@"optPlayRepeat"];

	NSArray *menuArray = [[aMenu itemArray] retain];

	for(i = 0; i < [menuArray count]; i++){

		record = [menuArray objectAtIndex:i];

		tag = [record tag];

		// set state
		if(tag == playRepeat){
			[record setState:1];
		}else{
			[record setState:0];
		}
	}

	[menuArray release];
}
//=======================================================================
#pragma mark - Delegate -
//=======================================================================
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	[self updateMenuItem:menu];
}


@end
