#import "MenuItemPlayVideo.h"
#import "FileAttributeExtension.h"
#import "UserDefaultsExtension.h"

static NSString *defaultKeyName1 = @"optDefaultAppPlayer";
static NSString *defaultKeyName2 = @"optDefaultAppPlayerPath";

@implementation MenuItemPlayVideo

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	[self setMenuImage];

	// add observer
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults addObserver:self forKeyPath:defaultKeyName1 options:0 context:nil];
	[defaults addObserver:self forKeyPath:defaultKeyName2 options:0 context:nil];

}

//------------------------------------
// setMenuImage
//------------------------------------
- (void)setMenuImage
{

	NSImage *image = nil;

	if([self defaultBoolValue:@"optShowMenuIcon"] == YES){
		if([self defaultBoolValue:defaultKeyName1] == YES){
			NSString *filePath = [self defaultStringValue:defaultKeyName2];
			if([self checkFileExist:filePath] != FILE_EXIST_NOT_FOUND){
				image = [[NSWorkspace sharedWorkspace] iconForFile:filePath];
				[image setScalesWhenResized:YES];
				[image setSize:NSMakeSize(16,16)];
			}
		}

		if(image == nil){
			image = [NSImage imageNamed:@"icon_video"];
			[image setScalesWhenResized:YES];
			[image setSize:NSMakeSize(14,14)];
		}

	}

	[self setImage:image];
}
//------------------------------------
// observeValueForKeyPath
//------------------------------------
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
	if([keyPath isEqualToString:defaultKeyName1] || [keyPath isEqualToString:defaultKeyName2]){
		[self setMenuImage];
	}
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults removeObserver:self forKeyPath:defaultKeyName1];
	[defaults removeObserver:self forKeyPath:defaultKeyName2];
	
	[super dealloc];
}

@end
