#import "MenuItemScaleToFit.h"
#import "UserDefaultsExtension.h"

static NSString *defaultKeyName = @"optMovieKeepAspect";

@implementation MenuItemScaleToFit

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// set action
	[self setTarget:self];
	[self setAction:NSSelectorFromString(@"changeScaleToFit:")];

	[self setMenuState];

	// add observer
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults addObserver:self forKeyPath:defaultKeyName options:0 context:nil];

}
//------------------------------------
// changeScaleToFit
//------------------------------------
- (IBAction)changeScaleToFit:(id)sender
{
	BOOL keepAspect = [self defaultBoolValue:defaultKeyName];
	// set default
	[self setDefaultBoolValue:!keepAspect key:defaultKeyName];
}
//------------------------------------
// setMenuState
//------------------------------------
- (void)setMenuState
{
	BOOL keepAspect = [self defaultBoolValue:defaultKeyName];
	[self setState:!keepAspect];
}
//------------------------------------
// observeValueForKeyPath
//------------------------------------
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
	if([keyPath isEqualToString:defaultKeyName]){
		[self setMenuState];
	}
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults removeObserver:self forKeyPath:defaultKeyName];
	
	[super dealloc];
}

@end
