#import "MovieAttributeExtension.h"

@implementation NSObject(movieAttributeExtension_)

//------------------------------------
// createMovieFrameImageAtTime
//------------------------------------
- (NSImage*)createMovieFrameImageAtTime:(QTMovie*)movie sec:(float)sec
{

	QTTime time;
	time.timeScale = [movie duration].timeScale;
	time.timeValue = sec * time.timeScale;
	if(time.timeValue > [movie duration].timeValue){
		time.timeValue = [movie duration].timeValue;
	}
	if(time.timeValue < 0){
		time.timeValue = 0;
	}
	return [movie frameImageAtTime:time];
}
/*
//------------------------------------
// movieLoadStatus
// needs <QuickTime/QuickTime.h>
//------------------------------------
- (float)movieLoadStatus:(QTMovie*)movie
{

	if(movie != nil){

		// typedef long TimeValue;
		TimeValue loadStatus;
		GetMaxLoadedTimeInMovie([movie quickTimeMovie], &loadStatus);

		// typedef struct { long long timeValue; long timeScale; long flags; } QTTime
		QTTime qtDuration	 = [movie duration];
		long long duration = qtDuration.timeValue;

		if(duration > 0){
			return ((float)loadStatus) / ((float)duration);
		}
		else{
			return 0;
		}
	}
	else {
		return 0;
	}
}
*/

//------------------------------------
// postVideoProcDidChangedNotification
//------------------------------------
- (void)postVideoProcDidChangedNotification:(BOOL)isProc
{
	// post notification
	NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
	[nc postNotificationName:VIDEO_NOTIF_PROC_DID_CHANGED object:[NSNumber numberWithBool:isProc]];
}
//------------------------------------
// postVideoPlayActionDidChangedNotification
//------------------------------------
- (void)postVideoPlayActionDidChangedNotification:(BOOL)isPlay
{
	// post notification
	NSNotificationCenter *nc = [NSNotificationCenter defaultCenter];
	[nc postNotificationName:VIDEO_NOTIF_PLAY_ACTION_DID_CHANGED object:[NSNumber numberWithBool:isPlay]];
}

@end