/* MoviePlayerView */

#import <Cocoa/Cocoa.h>
#import <QTKit/QTKit.h>
#import "FullScreenWindow.h"
#import "VideoPlayerStatus.h"

@interface MoviePlayerView : QTMovieView
{

	IBOutlet NSMenu *cmMovieView;

	float playRate_;
	NSString *errorDescription_;
	BOOL isCurrentPlaying_;
	BOOL isBeforeProcPlaying_;
	BOOL isAvailable_;
	NSTimer *timeStatusTimer_;

	NSTrackingRectTag trackingRect_;
}

- (BOOL)setPlayerView:(NSDictionary*)params isPlay:(BOOL)isPlay;
- (void)deletePlayerView;

- (void)setMoviePlay:(BOOL)isPlay isAction:(BOOL)isAction;
- (void)setMovieVolume:(float)volume;
- (void)setMovieRate:(float)rate;
- (void)setMovieAspectRatio:(BOOL)keepAspect;
- (void)replayMovie;

- (void)setMovieCurrentTime:(NSTimeInterval)time;
- (void)setMovieCurrentTimeWithSecond:(float)sec;
- (void)skipMovieTime:(float)interval;
- (void)gotoMovieTime:(int)toPos;
- (void)startTimeStatusTimer;
- (void)initTimeStatus;
- (void)updateTimeStatus;

- (void)changeVideoSizeScale:(float)scale;

- (void)postVideoObjectChangedNotification:(NSDictionary*)params;
- (void)postVideoLoadingChangedNotification:(BOOL)isLoading;
- (void)postVideoLoadedChangedNotification:(BOOL)isLoaded;
- (void)postVideoPlayChangedNotification:(BOOL)isPlaying;
- (void)postVideoTimeInitedNotification:(NSDictionary*)params;
- (void)postVideoTimeChangedNotification:(NSDictionary*)params;
- (void)postVideoRateChangedNotification:(float)rate;
- (void)postVideoStatusChangedNotification:(NSDictionary*)params;
- (void)postVideoSizeInResizeNotification:(BOOL)isStart;
- (void)postClearNotifications;

- (void)createMouseTracking;
- (void)removeMouseTracking;

- (void)setPlayRate:(float)playRate;
- (float)playRate;
- (void)setTimeStatusTimer:(NSTimer*)timeStatusTimer;
- (void)clearTimeStatusTimer;
- (NSTimer*)timeStatusTimer;

- (void)setErrorDescription:(NSString*)errorDescription;
- (NSString*)errorDescription;
- (void)setIsCurrentPlaying:(BOOL)isCurrentPlaying;
- (BOOL)isCurrentPlaying;
- (void)setIsBeforeProcPlaying:(BOOL)isBeforeProcPlaying;
- (BOOL)isBeforeProcPlaying;
- (void)setIsAvailable:(BOOL)isAvailable;
- (BOOL)isAvailable;
- (BOOL)isFullScreen;

- (BOOL)isPlaying;
- (BOOL)isContinuePlaying;
- (BOOL)isEndFrame;
- (BOOL)hasDuration;
- (BOOL)hasMovie;
- (BOOL)hasImage;
- (int)movieCurrentTimeSec;
- (NSImage*)movieCurrentFrameImage;

@end
