#import "OverlayAnimation.h"

@implementation OverlayAnimation

//------------------------------------
// initWithViewAnimations
//------------------------------------
- (id)initWithViewAnimations:(NSArray*)viewAnimations fadeType:(int)fadeType notifNames:(NSArray*)notifNames
{
	if (self = [super initWithViewAnimations:viewAnimations]){

		[self setFadeType:fadeType];

		// set notification
		if([notifNames count] > 0){
			NSNotificationCenter *nc=[NSNotificationCenter defaultCenter];
			int i;
			for(i = 0; i < [notifNames count]; i++){
				[nc addObserver:self selector:@selector(handleStopNotificationDidReceived:) name:[notifNames objectAtIndex:i] object:nil];
			}
		}

		return self;

	}
	return nil;
}

//=======================================================================
// method
//=======================================================================
//=======================================================================
// handler
//=======================================================================
//------------------------------------
// handleStopNotificationDidReceived
//------------------------------------
- (void)handleStopNotificationDidReceived:(NSNotification *)notification
{
	BOOL isStop = [[notification object] boolValue];

	// stop animation
	if(isStop == YES){
		[super stopAnimation];
	}
	// continue animation
	else{
//		[super startAnimation];
	}

}
//------------------------------------
// fadeType
//------------------------------------
- (void)setFadeType:(int)fadeType
{
	fadeType_ = fadeType;
}
- (int)fadeType
{
	return fadeType_;
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{	
	[[NSNotificationCenter defaultCenter] removeObserver:self];

	[super dealloc];
}

@end
