/* OverlayControllerWindow */

#import <Cocoa/Cocoa.h>
#import "FullScreenWindow.h"
#import "OverlayAnimation.h"
#import "WindowInfoStatus.h"
#import "VideoPlayerStatus.h"

@interface OverlayControllerWindow: NSWindow

{

	IBOutlet FullScreenWindow *playerWindow;

	BOOL isFullScreen_;

	float titleBarHeight_;
	
	BOOL isOpenTimer_;
	NSTimer *openTimer_;

	BOOL isCloseTimer_;
	NSTimer *closeTimer_;

	NSTrackingRectTag trackingRect_;

}

- (void)open;
- (void)openWithFade;

- (void)close;
- (void)closeWithFade;

- (void)startOpenTimer;
- (void)startCloseTimer;

- (void)openWithTimer;
- (void)closeWithTimer;

- (void)fadeInWindow;
- (void)fadeOutWindow;

- (void)createMouseTracking;
- (void)removeMouseTracking;

- (void)adjustFrame:(NSRect)childRect parentRect:(NSRect)parentRect isDisplay:(BOOL)isDisplay;

- (void)setOpenTimer:(NSTimer*)openTimer;
- (void)clearOpenTimer;
- (NSTimer*)openTimer;
- (void)setIsOpenTimer:(BOOL)isOpenTimer;
- (BOOL)isOpenTimer;

- (void)setCloseTimer:(NSTimer*)closeTimer;
- (void)clearCloseTimer;
- (NSTimer*)closeTimer;
- (void)setIsCloseTimer:(BOOL)isCloseTimer;
- (BOOL)isCloseTimer;

- (void)setIsFullScreen:(BOOL)isFullScreen;
- (BOOL)isFullScreen;

@end