#import "PopUpButtonLabelColor.h"
#import "CellAttributeExtension.h"

@implementation PopUpButtonLabelColor

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// createSubMenu
	subMenu_ = [[[NSMenu alloc] initWithTitle:@"labelColorMenu"] autorelease];
	[self createSubMenu:subMenu_];

	//set delegate menu
	[subMenu_ setDelegate:self];

}
//------------------------------------
// changeLabelColor
//------------------------------------
- (IBAction)changeLabelColor:(id)sender
{
	// none
}
//------------------------------------
// createSubMenu
//------------------------------------
- (void)createSubMenu:(NSMenu*)aMenu
{

	NSArray *cols;
	NSString *itemName;
	NSColor *itemColor;
	int colorNo;
	int i;
	id record;

	// remove menuItem
	while (record = [[[aMenu itemArray] objectEnumerator] nextObject]) {
		[aMenu removeItem:record];
	}

	NSArray *menuArray = [self labelColorList];
	NSMenuItem *menuItem;

	for(i = 0; i < [menuArray count]; i++){

		cols = [[menuArray objectAtIndex:i] componentsSeparatedByString:@","];
		
		// add item separator
        if([[cols objectAtIndex:0] isEqualToString:@"-"]){
			[aMenu addItem:[NSMenuItem separatorItem]];
			continue;
		}

		itemName = [cols objectAtIndex:0];
		colorNo = [[cols objectAtIndex:1] intValue];

		// label color
		itemColor = [self getLabelColor:colorNo];
		if(itemColor == nil){
 			itemColor = [NSColor blackColor];
		}
 
		NSDictionary *attributes = [NSDictionary dictionaryWithObjectsAndKeys:
										itemColor, NSForegroundColorAttributeName,
										nil
									];

		// set action
// 		SEL sel = NSSelectorFromString(@"changeLabelColor:");

		menuItem = [[[NSMenuItem alloc] initWithTitle:@"" action:nil keyEquivalent:@""] autorelease];
		[menuItem setAttributedTitle:[[[NSMutableAttributedString alloc] initWithString:itemName attributes:attributes] autorelease]];
		[menuItem setTag:colorNo];
//		[menuItem setTarget:self];
//		[menuItem setRepresentedObject:[NSNumber numberWithInt:colorNo]];

		[aMenu addItem:menuItem];
	}

	[self setMenu:aMenu];

//	[menuArray release];

}

//------------------------------------
// menuNeedsUpdate
//------------------------------------
-( void )menuNeedsUpdate:(NSMenu *)menu
{
	// none
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[subMenu_ release];	
	[super dealloc];
}

@end
