#import "RoundImageCell.h"
#import "ConvertExtension.h"
#import "CellAttributeExtension.h"

@implementation RoundImageCell
//------------------------------------
// init
//------------------------------------
- (id)init
{
    if (self = [super init])
	{
		[self setIsExist:NO];
   }
    return self;
}
//------------------------------------
// drawInteriorWithFrame
//------------------------------------
- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView*)controlView
{

    NSPoint	imagePoint;

    imagePoint.x = cellFrame.origin.x;
    imagePoint.y = cellFrame.origin.y;

    // draw image
    if([self image]){

		NSImage *image = [[self image] copy];

		// set image size
		[image setSize:[self setCellImageSize:[image size]
									frameSize:cellFrame.size
									paddingSize:NSMakeSize(2,2)
						]
		];
		[image setScalesWhenResized:YES];

		// set image rect
		NSRect imageRect = [self setCellImageRect:[image size]
										frameRect:cellFrame
							];

		imagePoint.x += imageRect.origin.x;
		imagePoint.y += imageRect.origin.y;

        if([controlView isFlipped]) {
            imagePoint.y += [image size].height;
        }
		
		// set image round rect
		NSRect imageRoundRect = [self setCellImageRoundRect:[image size]
													frameRect:cellFrame
								];

		// draw image rect
		NSBezierPath *imagePath = [self setRoundPathForRect:imageRoundRect radius:5];
		[NSGraphicsContext saveGraphicsState];

		[imagePath addClip];

		// draw image
		[image compositeToPoint:imagePoint operation:NSCompositeSourceOver];

		[NSGraphicsContext restoreGraphicsState];

		[image release];

		//
		// draw label
		//
		if([self isExist] == NO){
			// now origin.y is buggy
			NSRect imageBounds;
			imageBounds.origin.x = cellFrame.origin.x + imageRect.origin.x;
			imageBounds.origin.y = cellFrame.origin.y + imageRect.origin.y;
//			if([controlView isFlipped]) {
//				imageBounds.origin.y += (imageRect.size.height - imageRect.origin.y);
//			}
			imageBounds.size = imageRect.size;

			// draw label
			NSString *labelTitle = LABEL_NAME_NOT_FOUND;
			if(![labelTitle isEqualToString:@""]){
				NSSize stringSize = [labelTitle sizeWithAttributes:nil];
				if( imageBounds.size.width > stringSize.width + 8 &&
					imageBounds.size.height > stringSize.height + 4
				){
					// draw label
					[self drawLabelAndString:imageBounds
									withString:labelTitle
									fontSize:LABEL_STATUS_FSIZE
									fontColor:[NSColor whiteColor]
									labelColor:[self getLabelColor:LABEL_COLOR_NOT_FOUND]
									align:CELL_ALIGN_RIGHT
									valign:CELL_VALIGN_TOP
									hPadding:LABEL_STATUS_HPADDING
									vPadding:LABEL_STATUS_VPADDING
									radius:LABEL_STATUS_RADIUS
					];
				}
			}
		}

    }

}
//------------------------------------
// isExist
//------------------------------------
- (void)setIsExist:(BOOL)isExist
{
	isExist_ = isExist;
}
- (BOOL)isExist
{
	return isExist_;
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
    [super dealloc];
}

@end
