/* TBArrayController */

#import <Cocoa/Cocoa.h>

@interface TBArrayController : NSObject
{
	IBOutlet NSArrayController *filelistArrayController;
    IBOutlet NSArrayController *applistArrayController;
	IBOutlet NSTreeController *playlistTreeController;
	IBOutlet id MacVideoTunes_AppDelegate;

}

- (int)getMaxIntValueFromEntityWithColumn:(NSString*)entityName column:(NSString*)column;
- (int)getMaxIntValueFromArrayWithColumn:(NSArray*)array column:(NSString*)column;
- (int)getMaxIndexFromChildItems:(NSManagedObject*)item;

- (NSManagedObjectContext*)getManagedObjectContext:(NSString*)entityName;

- (NSManagedObject*)getSelectedObject:(NSString*)entityName;
- (NSArray*)getSelectedObjects:(NSString*)entityName;
- (NSArray*)getAllObjects:(NSString*)entityName;
- (NSArray*)getChildObjects:(NSManagedObject*)parent;
- (NSArray*)getObjectsWithPred:(NSString*)entityName pred:(NSPredicate*)pred;

- (void)removeAllObjects:(NSString*)entityName;
- (void)removeObjectsWithArray:(NSArray*)array;
- (void)removeObject:(id)record;

- (NSManagedObject *)insertPlaylist:(int)index
					title:(NSString*)title
					parentItem:(id)parentItem
					isFolder:(BOOL)isFolder;

- (void)addItemToParent:(NSManagedObject *)targetItem item:(NSManagedObject *)item maxNum:(BOOL)maxNum;
- (NSManagedObject*)getUpdateTargetItem:(NSManagedObject*)item;
- (NSMutableArray*)getTreeItems:(NSManagedObject*)item;
- (void)removeTreeItems:(NSManagedObject*)item;
- (void)resetItemIndex:(NSManagedObject*)insItem
			parentItem:(NSManagedObject*)parentItem
			targetItem:(NSManagedObject*)targetItem
			insIndex:(int)insIndex;

@end
