#import "TextFieldDefaultApp.h"
#import "ViewPrefs.h"

@implementation TextFieldDefaultApp

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	// set registerForDraggedTypes
	[self registerForDraggedTypes:
				[NSArray arrayWithObjects:
						NSFilenamesPboardType,
						nil]
				];

}
//=======================================================================
// methods
//=======================================================================
//=======================================================================
// drag & drop
//=======================================================================
//------------------------------------
// draggingEntered
//------------------------------------
- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)info
{

	// Get pboard
	NSPasteboard *pboard;
	pboard = [info draggingPasteboard];
	id draggingSource = [info draggingSource];

	if ([self isEnabled] == NO){
		return NSDragOperationNone;
	}

	if (!pboard){
		return NSDragOperationNone;
	}

	// ignore self
	if (draggingSource == self) {
		return NSDragOperationNone;
	}

	// from sting
	if ([[pboard types] containsObject:NSFilenamesPboardType]){
		return NSDragOperationCopy;
	}

	return NSDragOperationNone;

}
//------------------------------------
// draggingExited
//------------------------------------
- (void)draggingExited:(id <NSDraggingInfo>)info
{
	// none
}
//------------------------------------
// draggingUpdated
//------------------------------------
- (NSDragOperation)draggingUpdated:(id <NSDraggingInfo>)info
{

	// Get pboard
	NSPasteboard *pboard;
	pboard = [info draggingPasteboard];
	id draggingSource = [info draggingSource];

	if ([self isEnabled] == NO){
		return NSDragOperationNone;
	}

	if (!pboard){
		return NSDragOperationNone;
	}

	// ignore self
	if (draggingSource == self) {
		return NSDragOperationNone;
	}

	// from sting
	if ([[pboard types] containsObject:NSFilenamesPboardType]){
		return NSDragOperationCopy;
	}

	return NSDragOperationNone;

}
//------------------------------------
// prepareForDragOperation
//------------------------------------
- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)info
{
	return YES;
}
//------------------------------------
// performDragOperation
//------------------------------------
- (BOOL)performDragOperation:(id <NSDraggingInfo>)info
{

	NSPasteboard *pboard = [info draggingPasteboard];
	id draggingSource = [info draggingSource];

	if ([self isEnabled] == NO){
		return NO;
	}

	if (!pboard) {
        return NO;
	}

	// ignore self
	if (draggingSource == self) {
		return NO;
	}

	// Check pboard type
	// from file name
	if ([[pboard types] containsObject:NSFilenamesPboardType]){

		NSArray *filePaths = [pboard propertyListForType:NSFilenamesPboardType];
		if([filePaths count] > 0){
			return [viewPrefs setDefaultAppPlayer:filePaths];
		}
	}

	return NO;

}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{

	[super dealloc];
}

@end
