#import "TextFieldDefaultPlayer.h"
#import "UserDefaultsExtension.h"

static NSString *defaultKeyName = @"optDefaultAppPlayer";

@implementation TextFieldDefaultPlayer

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	[self setTextFieldColor];

	// add observer
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults addObserver:self forKeyPath:defaultKeyName options:0 context:nil];

}
//------------------------------------
// setTextFieldColor
//------------------------------------
- (void)setTextFieldColor
{

	BOOL isEnabled = [self defaultBoolValue:defaultKeyName];
	NSColor *color = [NSColor blackColor];

	if(isEnabled == NO){
		color = [NSColor grayColor];
	}

	[self setTextColor:color];

}
//------------------------------------
// observeValueForKeyPath
//------------------------------------
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context
{
	
	if([keyPath isEqualToString:defaultKeyName]){
		[self setTextFieldColor];
	}
	
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{

	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	[defaults removeObserver:self forKeyPath:defaultKeyName];
	
	[super dealloc];
}

@end
