#import "TextFieldTimeStatus.h"
#import "UserDefaultsExtension.h"
#import "ConvertExtension.h"

@implementation TextFieldTimeStatus

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{

	[self setIsLoaded:NO];
	[self setStringValue:@"--/--"];
	[self setTextColor:[NSColor grayColor]];

	// set notification
	NSNotificationCenter *nc=[NSNotificationCenter defaultCenter];
	[nc addObserver:self selector:@selector(handleVideoObjectDidChanged:) name:VIDEO_NOTIF_OBJECT_DID_CHANGED object:nil];
	[nc addObserver:self selector:@selector(handleVideoTimeDidChanged:) name:VIDEO_NOTIF_TIME_DID_INITED object:nil];
	[nc addObserver:self selector:@selector(handleVideoTimeDidChanged:) name:VIDEO_NOTIF_TIME_DID_CHANGED object:nil];

}
//------------------------------------
// handleVideoObjectDidChanged
//------------------------------------
- (void)handleVideoObjectDidChanged:(NSNotification *)notification
{
	NSDictionary *params = [notification object];
	BOOL hasDuration = [[params valueForKey:@"hasDuration"] boolValue];
	if(hasDuration == NO){
		[self setTextColor:[NSColor grayColor]];
		[self setStringValue:@"--/--"];
	}else{
		[self setTextColor:[NSColor whiteColor]];
	}
	[self setIsLoaded:hasDuration];

}
//------------------------------------
// handleVideoPlayDidChanged
//------------------------------------
- (void)handleVideoTimeDidChanged:(NSNotification *)notification
{

	// for closing player
	if([self isLoaded] == NO){
		return;
	}

	NSDictionary *params = [notification object];

	int currentTime = [[params valueForKey:@"currentTime"] intValue];
	int duration = [[params valueForKey:@"duration"] intValue];

	NSString *string = [NSString stringWithFormat:@"%@ / %@"
							, [self convertTimeToString:currentTime]
							, [self convertTimeToString:duration]
						];

	[self setStringValue:string];

}

//------------------------------------
// isLoaded
//------------------------------------
- (void)setIsLoaded:(BOOL)isLoaded
{
    isLoaded_ = isLoaded;
}
- (BOOL)isLoaded
{
	return isLoaded_;
}
//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{
	[[NSNotificationCenter defaultCenter] removeObserver:self];

	[super dealloc];
}

@end
