#import <Cocoa/Cocoa.h>
#import "ItemInfoStatus.h"
#import "KeyInfoStatus.h"
#import "PasteboardTypes.h"

@interface ThumbsMatrix : NSMatrix
{

	IBOutlet id viewMain;
	IBOutlet NSArrayController *filelistArrayController;

	IBOutlet NSTextField *txtPageResult;

	IBOutlet NSButton *btnPagePrev;
	IBOutlet NSButton *btnPageNext;
	IBOutlet NSMenu *cmFilelist;

	int selectedIndex_;
	int pointedIndex_;
	int startIndex_;
	int endIndex_;

	BOOL isChangedArray_;
	BOOL isChangedIndex_;
	BOOL isPointedCell_;

}
- (IBAction)changeMatrix:(id)sender;
- (IBAction)changeCellSize:(id)sender;
- (IBAction)changeMatrixCols:(id)sender;
- (IBAction)changeMatrixPage:(id)sender;
- (IBAction)moveMatrixPage:(id)sender;
- (IBAction)selectAll:(id)sender;

- (void)changePageButtonEnable;
- (NSDictionary*)checkIsChangedPage;
- (void)setPageResultStatus;

- (void)createMatrix:(int)startIndex endIndex:(int)endIndex;
- (void)retileMatrix;
- (void)clearMatrix;
- (void)updateSelectedCell;
- (BOOL)selectMovedCell:(int)arrow isShift:(BOOL)isShift isCmd:(BOOL)isCmd;
- (BOOL)selectIndexCell:(int)index isShift:(BOOL)isShift isCmd:(BOOL)isCmd;
- (void)changeSelectionIndexes:(int)index
						isShift:(BOOL)isShift
						isCmd:(BOOL)isCmd;
- (void)adjustScrollPosition:(NSPoint)cellPosition;
- (NSSize)calcCellSize:(NSSize)frameSize cols:(int)cols;

- (int)maxCols;
- (void)setStartIndex:(int)index;
- (int)startIndex;
- (void)setEndIndex:(int)index;
- (int)endIndex;

- (void)setSelectedIndex:(int)index;
- (int)selectedIndex;
- (void)setPointedIndex:(int)index;
- (int)pointedIndex;

- (int)lastIndex;
- (int)totalResults;
- (int)maxResults;

@end
