#import "ThumbsScrollView.h"
#import "ViewMain.h"

@implementation ThumbsScrollView

//=======================================================================
// awake App
//=======================================================================
- (void)awakeFromNib
{
	//
	// for dragging into out of matrix
	//
	// set registerForDraggedTypes
	[self registerForDraggedTypes:[NSArray arrayWithObjects:NSFilenamesPboardType, nil]];

}
//=======================================================================
// drag & drop
//=======================================================================
//------------------------------------
// draggingEntered
//------------------------------------
- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)info
{

	// Get pboard
	NSPasteboard *pboard;
	pboard = [info draggingPasteboard];
	id draggingSource = [info draggingSource];

	if (!pboard){
		return NSDragOperationNone;
	}

	// ignore self
	if ([[draggingSource superview] superview] == self) {
		return NSDragOperationNone;
	}

	// from file path
	if ([[pboard types] containsObject:NSFilenamesPboardType]){
		return NSDragOperationCopy;
	}

	return NSDragOperationNone;

}
//------------------------------------
// draggingExited
//------------------------------------
- (void)draggingExited:(id <NSDraggingInfo>)info
{
	// none
}
//------------------------------------
// draggingUpdated
//------------------------------------
- (NSDragOperation)draggingUpdated:(id <NSDraggingInfo>)info
{

	// Get pboard
	NSPasteboard *pboard;
	pboard = [info draggingPasteboard];
	id draggingSource = [info draggingSource];

	if (!pboard){
		return NSDragOperationNone;
	}

	// ignore self
	if ([[draggingSource superview] superview] == self) {
		return NSDragOperationNone;
	}

	// from file path
	if ([[pboard types] containsObject:NSFilenamesPboardType]){
		return NSDragOperationCopy;
	}

	return NSDragOperationNone;

}
//------------------------------------
// prepareForDragOperation
//------------------------------------
- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)info
{
	return YES;
}
//------------------------------------
// performDragOperation
//------------------------------------
- (BOOL)performDragOperation:(id <NSDraggingInfo>)info
{

	NSPasteboard *pboard = [info draggingPasteboard];
	id draggingSource = [info draggingSource];

	if (!pboard) {
        return NO;
	}

	// ignore self
	if ([[draggingSource superview] superview] == self) {
		return NO;
	}

	// Check pboard type
	// from filepath
	if ([[pboard types] containsObject:NSFilenamesPboardType]){
		NSArray *filePaths = [pboard propertyListForType:NSFilenamesPboardType];
		if([filePaths count] > 0){	
			SEL sel = NSSelectorFromString(@"importItemWithFilePaths:");
			[viewMain performSelector:sel withObject:filePaths afterDelay:0.1];
			return YES;
		}
	}

	return YES;

}
//------------------------------------
// draggingSourceOperationMaskForLocal
//------------------------------------
- (unsigned int)draggingSourceOperationMaskForLocal:(BOOL)isLocal
{
	if(isLocal == YES){
		return	NSDragOperationLink;
	}else{
		return	NSDragOperationLink;
	}
}
//------------------------------------
// mouseDown
//------------------------------------
- (void)mouseDown:(NSEvent *)event
{

	// get focus
	[self becomeFirstResponder];

}
//------------------------------------
// acceptsFirstResponder
//------------------------------------
-(BOOL)acceptsFirstResponder
{
	return YES;
}

//------------------------------------
// dealloc
//------------------------------------
- (void)dealloc
{

	[super dealloc];
}

@end
