/* ViewChapter */

#import <Cocoa/Cocoa.h>
#import <QTKit/QTKit.h>
#import "ChapterMatrix.h"
#import "ChapterWindow.h"
#import "RoundedView.h"
#import "MoviePlayerView.h"
#import "WindowInfoStatus.h"

@interface ViewChapter : NSObject
{

	IBOutlet id viewPlayer;
	IBOutlet id viewGallery;
	IBOutlet id viewProcStatus;
	IBOutlet id tbArrayController;

    IBOutlet ChapterMatrix *chapterMatrix;
    IBOutlet ChapterWindow *chapterWindow;
    IBOutlet RoundedView *roundedView;

	IBOutlet NSTextField *txtTitle;
	IBOutlet MoviePlayerView *moviePlayerView;

	NSMutableArray *chapterList_;
	NSDictionary *params_;

	id itemObject_;
	BOOL isPlay_;

}
- (IBAction)openChapterWindow:(id)sender;
- (IBAction)closeChapterWindow:(id)sender;
- (IBAction)changeChapterWindow:(id)sender;

- (IBAction)playItemChapter:(id)sender;
- (IBAction)createItemChapter:(id)sender;
- (IBAction)removeItemChapter:(id)sender;
- (IBAction)showImageInFinder:(id)sender;

- (void)openChapterView:(BOOL)isCreate;
- (void)playSelectedChapter:(BOOL)isOpen isFront:(BOOL)isFront;

- (void)setChapter:(NSDictionary*)params;
- (void)createChapterList:(NSDictionary*)params;
- (void)removeChapterList;
- (int)getUpdatedIndex:(NSString*)chapterId;

- (BOOL)createChapterAtCurrentTime:(QTMovie*)movie
								uniqueId:(NSString*)uniqueId
								chapterId:(NSString*)chapterId
								timeSec:(int)timeSec
								hasImage:(BOOL)hasImage
								record:(id)record;
- (BOOL)createChapterAtIntervalTime:(QTMovie*)movie
							uniqueId:(NSString*)uniqueId
							intervalSec:(int)intervalSec
							hasImage:(BOOL)hasImage
							record:(id)record;
- (BOOL)createChapterImageAtTime:(QTMovie*)movie
						uniqueId:(NSString*)uniqueId
						chapterId:(NSString*)chapterId
						timeSec:(int)timeSec
						isCurrent:(BOOL)isCurrent
						isCheckFolder:(BOOL)isCheckFolder
						showAlert:(BOOL)showAlert;

- (NSArray*)createChapterSets:(NSString*)chapterSet;
- (BOOL)updateChapterSet:(NSString*)chapterId record:(id)record count:(int*)count;
- (BOOL)removeChapterSet:(NSString*)chapterId record:(id)record count:(int*)count;
- (void)postItemChapterDidChangedNotification;

- (NSMutableArray*)chapterList;

- (void)setParams:(NSDictionary*)params;
- (NSDictionary*)params;
- (void)setItemObject:(id)itemObject;
- (id)itemObject;

- (void)setIsPlay:(BOOL)isPlay;
- (BOOL)isPlay;
- (BOOL)isVisibleWindow;
- (BOOL)isNotVisibleWindow;
- (BOOL)isKeyWindow;

- (int)movieDurationSec;

- (BOOL)isSelectedItem;
- (BOOL)canCreateChapter;
- (BOOL)canShowImage;
- (BOOL)hasMovie;
- (BOOL)hasDuration;
- (BOOL)hasImage;
- (BOOL)isAvailable;

@end
