/* ViewItemInfo */

#import <Cocoa/Cocoa.h>
#import "ItemInfoStatus.h"

@interface ViewItemInfo : NSObject
{

	IBOutlet id fileItemManager;
	IBOutlet id tbArrayController;
	IBOutlet NSArrayController *filelistArrayController;

	IBOutlet NSWindow *infoWindow;
	IBOutlet NSWindow *thumbsSettingWindow;

	IBOutlet NSImageView *imagePreview;
	IBOutlet NSImageView *imageFileIcon;

	IBOutlet NSTextField *txtTitle;
	IBOutlet NSTextField *txtFilePath;
	IBOutlet NSTextField *txtPathTitle;
	IBOutlet NSTextField *txtInfoTitle;
	IBOutlet NSTextField *txtInfoLabelColor;
	IBOutlet NSTextField *txtInfoThumbs;
	IBOutlet NSTextView *txtFileInfo;
	IBOutlet NSPopUpButton *pbtnLabelColor;

	IBOutlet NSButton *btnNext;
	IBOutlet NSButton *btnPrev;
	IBOutlet NSButton *btnPathSelect;
	IBOutlet NSButton *btnUpdate;
	IBOutlet NSButton *btnCreateImage;
	IBOutlet NSButton *btnSearchImage;
	IBOutlet NSButton *btnSearchItem;

	NSArray *updateKeys_;
	NSString *title_;
	NSString *filePath_;
	int labelColorNo_;

	BOOL canEditTitle_;
	BOOL canEditFilePath_;
	BOOL canEditLabelColorNo_;
	BOOL isSingleSelected_;

}
- (IBAction)openInfoWindow:(id)sender;
- (IBAction)openThumbsSettingWindow:(id)sender;
- (IBAction)closeThumbsSettingWindow:(id)sender;

- (IBAction)changeItemInfo:(id)sender;
- (IBAction)selectItemInfo:(id)sender;
- (IBAction)setItemFilePath:(id)sender;
- (IBAction)showItemInFinder:(id)sender;
- (IBAction)showImageInFinder:(id)sender;
- (IBAction)createItemThumbsImage:(id)sender;

- (BOOL)createItemInfo;
- (BOOL)updateItemInfo;
- (BOOL)updateFilelist:(NSArray*)updateKeys
					title:(NSString*)title 
					isChangedTitle:(BOOL)isChangedTitle
					filePath:(NSString*)filePath
					isChangedFilePath:(BOOL)isChangedFilePath
					labelColorNo:(int)labelColorNo
					isChangedLabelColorNo:(BOOL)isChangedLabelColorNo;

- (BOOL)createThumbsSetting;
- (void)setPreviewImage:(id)record;
- (BOOL)canCreateImage:(NSArray*)items;

- (void)setUpdateKeys:(NSArray*)updateKeys;
- (NSArray*)updateKeys;
- (void)setTitle:(NSString*)title;
- (NSString*)title;
- (void)setFilePath:(NSString*)filePath;
- (NSString*)filePath;
- (void)setLabelColorNo:(int)labelColorNo;
- (int)labelColorNo;


- (void)setCanEditTitle:(BOOL)canEditTitle;
- (BOOL)canEditTitle;
- (void)setCanEditFilePath:(BOOL)canEditFilePath;
- (BOOL)canEditFilePath;
- (void)setCanEditLabelColorNo:(BOOL)canEditLabelColorNo;
- (BOOL)canEditLabelColorNo;

- (void)setIsSingleSelected:(BOOL)isSingleSelected;
- (BOOL)isSingleSelected;

@end
