/* ViewMain */

#import <Cocoa/Cocoa.h>
#import "PreviewImageView.h"
#import "ItemInfoStatus.h"
#import "ProcInfoStatus.h"
#import "ImportTypes.h"
#import "ControlValues.h"

@interface ViewMain : NSObject
{

	IBOutlet id viewPlayer;
	IBOutlet id viewPlaylist;
	IBOutlet id tbArrayController;
	IBOutlet id fileItemManager;
	IBOutlet NSArrayController *filelistArrayController;

	IBOutlet NSWindow *mainWindow;

	IBOutlet NSSearchField *txtSearchField;
	IBOutlet NSButton *btnPagePrev;
	IBOutlet NSButton *btnPageNext;
	IBOutlet NSButton *btnPlay;
	IBOutlet NSProgressIndicator *indProc;

	IBOutlet NSButton *btnTabViewMainTable;
	IBOutlet NSButton *btnTabViewMainGrid;
	IBOutlet NSTabView *tabViewMainResult;
	IBOutlet NSTabView *tabViewMainStatus;
	IBOutlet NSTabView *tabViewMainSlider;

	IBOutlet PreviewImageView *imagePreview;

	IBOutlet NSSplitView *spvMain;
	IBOutlet NSSplitView *spvNavi;
	IBOutlet NSSplitView *spvHead;
 
	NSString *searchString_;
	NSPredicate *searchPred_;

	NSString *plistUniqueId_;
	BOOL plistIsFolder_;
	NSPredicate *plistPred_;

	NSPredicate *itemsPred_;
	NSString *itemsTitle_;

	NSString *windowTitle_;

}
- (IBAction)playItem:(id)sender;
- (IBAction)playItemWithTimer:(id)sender;
- (IBAction)searchMissingItems:(id)sender;

- (IBAction)importItemWithSelect:(id)sender;
- (IBAction)showItemInFinder:(id)sender;
- (IBAction)showImageInFinder:(id)sender;
- (IBAction)openItemWithApp:(id)sender;
- (IBAction)createItemThumbsImage:(id)sender;

- (IBAction)addItemToPlaylist:(id)sender;

- (IBAction)removeItem:(id)sender;
- (IBAction)removeItemFromLibrary:(id)sender;
- (IBAction)removeItemFromPlaylist:(id)sender;

- (IBAction)changePreviewImage:(id)sender;
- (IBAction)changeTabViewMainIndex:(id)sender;

- (void)playSelectedItem:(BOOL)isOpen isFront:(BOOL)isFront;
- (void)searchWithString:(NSString*)searchString pred:(NSPredicate*)pred;
- (void)searchWithPlaylist:(NSString*)uniqueId title:(NSString*)title isFolder:(BOOL)isFolder pred:(NSPredicate*)pred;
- (void)searchWithItems:(NSArray*)items title:(NSString*)title;
- (void)searchWithPredicate:(BOOL)withString withPlist:(BOOL)withPlist withItems:(BOOL)withItems;

- (void)importItemWithFilePaths:(NSArray*)filePaths;

- (void)changeTabViewMainResultIndex;
- (void)changeTabViewMainSliderIndex;
- (void)changeTabViewMainStatusIndex;
- (void)changeTabViewMainButtonEnable;
- (void)handleSearchStatusChanged:(int)status;

- (void)setWindowTitle:(NSString*)windowTitle;
- (NSString*)windowTitle;

- (void)setSearchString:(NSString*)searchString;
- (NSString*)searchString;
- (void)setSearchPred:(NSPredicate*)searchPred;
- (NSPredicate*)searchPred;

- (void)setPlistUniqueId:(NSString*)plistUniqueId;
- (NSString*)plistUniqueId;
- (void)setPlistIsFolder:(BOOL)plistIsFolder;
- (BOOL)plistIsFolder;

- (void)setPlistPred:(NSPredicate*)plistPred;
- (NSPredicate*)plistPred;

- (void)setItemsPred:(NSPredicate*)itemsPred;
- (NSPredicate*)itemsPred;
- (void)setItemsTitle:(NSString*)itemsTitle;
- (NSString*)itemsTitle;

- (BOOL)canRemoveItemFromApp;
- (BOOL)canRemoveItemFromPlaylist;
- (BOOL)isKeyMainWindow;
- (BOOL)isSearchWithPlaylist;

- (BOOL)hasImagePreview;

@end
