/* ViewPlayer */

#import <Cocoa/Cocoa.h>
#import "MoviePlayerView.h"
#import "FullScreenWindow.h"
#import "WindowInfoStatus.h"
#import "ItemInfoStatus.h"
#import "VideoPlayerStatus.h"
#import "ProcInfoStatus.h"

@interface ViewPlayer : NSObject
{

	IBOutlet id viewMain;
	IBOutlet id viewPrefs;
	IBOutlet id viewChapter;

	IBOutlet id tbArrayController;
	IBOutlet id viewProcStatus;
	
	IBOutlet NSArrayController *filelistArrayController;

	IBOutlet MoviePlayerView *moviePlayerView;
	IBOutlet FullScreenWindow *playerWindow;

	IBOutlet NSSlider *sliderPlayVolume;

	NSDictionary *params_;
	NSTimer *playTimer_;
	NSTimer *selectTimer_;

}

- (IBAction)openPlayerWindow:(id)sender;
- (IBAction)orderFrontPlayerWindow:(id)sender;
- (IBAction)controlMoviePlay:(id)sender;
- (IBAction)changePlayItem:(id)sender;
- (IBAction)seekMovieTime:(id)sender;
- (IBAction)skipMovieTime:(id)sender;
- (IBAction)gotoMovieTime:(id)sender;
- (IBAction)createItemThumbsImage:(id)sender;

- (BOOL)setPlayerView:(NSDictionary*)params
						isPlay:(BOOL)isPlay
						isOpen:(BOOL)isOpen
						isFront:(BOOL)isFront;
- (void)openPlayerView:(BOOL)isOpen isFront:(BOOL)isFront;
- (BOOL)openFileWithDefaultPlayer:(NSString*)filePath;

- (void)playItemWithTimer:(id)sender;
- (void)playRepeatItemWithTimer:(id)sender;
- (void)selectPlayItem:(int)tag
				interval:(float)interval
				withTimer:(BOOL)withTimer
				isLoop:(BOOL)isLoop;
- (void)selectItemWithTimer:(NSTimer*)aTimer;

- (void)handleVideoDidEnded:(NSNotification *)notification;
- (void)handleVideoPlayDidChanged:(NSNotification *)notification;

- (void)setPlayTimer:(NSTimer*)playTimer;
- (void)clearPlayTimer;
- (NSTimer*)playTimer;
- (void)setSelectTimer:(NSTimer*)selectTimer;
- (void)clearSelectTimer;
- (NSTimer*)selectTimer;

- (void)setParams:(NSDictionary*)params;
- (NSDictionary*)params;

- (BOOL)isMainPlayerWindow;
- (BOOL)isVisiblePlayerWindow;
- (BOOL)isFullScreenPlayerWindow;
- (BOOL)isTopScreenPlayerWindow;

- (BOOL)canCreateImage;
- (BOOL)canChangeImageScale;
- (BOOL)canChangeScaleToFit;

- (BOOL)isAvailable;
- (BOOL)isPlaying;
- (BOOL)isContinuePlaying;
- (BOOL)hasDuration;
- (BOOL)hasMovie;
- (BOOL)hasImage;

@end
