/* ViewPlaylist */

#import <Cocoa/Cocoa.h>
#import "PlaylistOutlineView.h"
#import "ImportTypes.h"

@interface ViewPlaylist : NSObject
{
	IBOutlet id viewMain;
	IBOutlet id fileItemManager;
	
	IBOutlet id tbArrayController;
	IBOutlet NSTreeController *playlistTreeController;

	IBOutlet NSWindow *mainWindow;
	IBOutlet PlaylistOutlineView *olvPlaylist;

	IBOutlet NSButton* btnAdd;
	IBOutlet NSButton* btnRemove;

	NSString *previousUniqueId_;
}
- (IBAction)addPlaylist:(id)sender;
- (IBAction)addFolder:(id)sender;

- (IBAction)searchItem:(id)sender;
- (IBAction)searchWithDeselectItem:(id)sender;
- (IBAction)removeItem:(id)sender;
- (IBAction)showItem:(id)sender;

- (IBAction)editItem:(id)sender;
- (IBAction)deselectItem:(id)sender;

- (IBAction)nullAction:(id)sender;

- (void)addItem:(NSString*)title
				isFolder:(BOOL)isFolder
				isSelect:(BOOL)isSelect
				isEdit:(BOOL)isEdit;

- (void)searchItemWithItem:(NSManagedObject*)item;
- (void)addItemToPlaylistWithParams:(NSDictionary*)params;
- (void)importItemWithParams:(NSDictionary*)params;

- (void)setControlButtonEnable;

- (BOOL)isSelectItem;
- (BOOL)isSelectFolder;
- (BOOL)isKeyMainWindow;

- (BOOL)canAddPlaylist;
- (BOOL)isDisplayPlaylist;

@end
